﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class Goal : MonoBehaviour
{
    public bool isGoal1;
    public int goals;
    public int goalsToWin;

    // Start is called before the first frame update
    void Start()
    {
        goalsToWin = 5;
        goals = 0;
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKeyDown(KeyCode.R) )
        {
            SceneManager.LoadScene("SampleScene");
        }

        if (Input.GetKeyDown(KeyCode.Escape))
        {
            Application.Quit();
        }
    }

    void OnCollisionEnter(Collision collision)
    {
        if (collision.collider.tag == "ball")
        {
            goals++;

            Ball ball = collision.collider.GetComponent<Ball>();

            if ( goals >= goalsToWin )
            {
                if( isGoal1 )
                {
                    endGame(ball, "Player 1 Wins!");
                }
                else
                {
                    endGame( ball, "Player 2 Wins!" );
                }
            }
            else
            {
                float startingX = Random.Range(0, 2) == 0 ? -1 : 1;
                float startingY = Random.Range(0, 2) == 0 ? -1 : 1;
                ball.transform.position = new Vector3(0f, 0f, 0f);
                ball.GetComponent<Rigidbody>().velocity = new Vector3(
                    ball.speed * startingX,
                    ball.speed * startingY, 
                    0f);
            }
        }
    }

    private static void endGame(Ball ball, string winningMessage )
    {
        GameObject.Find("Winner").GetComponent<TextMesh>().text = winningMessage;
        ball.Halt();
    }
}
